
/* configuration bits dans   project ->  project
   MCU name          18F46K22
   Oscil Frequency   Q=20MHz

 CONFIG1H : $300001 : 0x0022
CONFIG2L : $300002 : 0x001E
CONFIG2H : $300003 : 0x003C
CONFIG3H : $300005 : 0x0099
CONFIG4L : $300006 : 0x0080
CONFIG5L : $300008 : 0x000F
CONFIG5H : $300009 : 0x00C0
CONFIG6L : $30000A : 0x000F
CONFIG6H : $30000B : 0x00E0
CONFIG7L : $30000C : 0x000F
CONFIG7H : $30000D : 0x0040

 */

#define PI 3.14159
#define Version "16-07-2015"

 
const code char mesg0[]="Divers test avec 18F46K22 Q=20MHz x 4\r\n";
const code char mesg1[]="RS232 UART1  avec interface 2T\r\n";
const code char mesg2[]="Version : " Version"\r\n MikroC Pro 6.40\r\n";
const code char * Messages[]={mesg0,mesg1,mesg2};

#define TAB 9
#define CLS 12
#define CR 13
#define LF 10

sbit Led_Blanche at LATA5_bit ;     // RA5 output

unsigned char TEXTE[64];
unsigned char *txt;
unsigned char buffer1[64];
unsigned char CRam1[32];
char *p1;

unsigned int i,j,k,l;
unsigned int M;
unsigned int cnt;

volatile unsigned char c1;
volatile int Flag_Buffer;
volatile int Index1;
volatile unsigned int CptErr;
volatile unsigned int Nb_Pulses;
volatile unsigned int Nb_Over ;
volatile unsigned int Count1;

float f1,f2;
float Volt;

double df1,df2;



void strConstRamCpy(char *dest, const char *source);
void UART1_Write_CText(const char *txt);
void CRLF();



void Interrupts() iv 0x0008 ics ICS_AUTO
{
 if( INTCON.TMR0IF==1)
  {
      Nb_Over++;
     INTCON.TMR0IF=0;
  }
if (PIR1.RCIF==1)
  {
   while ((RCSTA.OERR==1)| (RCSTA.FERR==1))
  {
   c1=RCREG;           // efface drapeau OVERRUN
   RCSTA.SPEN=0;       // efface drapeau Frame error
   CptErr=CptErr + 1;
   RCSTA.SPEN=1;
  };

  c1 = RCREG;
  if ((c1==13)| (Index1>31))
  {
   buffer1[Index1]=0;
   Flag_Buffer=1;
   PIE1.RCIE=0 ; // interdit IT Reception UART
   }
   else
   {
   buffer1[Index1]=c1;
   Index1++;
   }
  PIR1.RCIF=0   ;
  }
 /*--- timer 1  -----------------
  if( PIR1.TMR1IF==1)
  {
        TMR1H=0x0B;
        TMR1L=0xDB; // 65536-62500=3035
        Count1++;
      if (Count1>7)   // 8x125 ms= 1 seconde
       {   Nb_Pulses=
           Total_Pulses= Total_Pulses + (Nb_Over<<8) + Nb_Pulses;
           TMR1H=0;TMR1L=0;

           Nb_Over=0;
          Led_Blanche= !Led_Blanche; // blink RA4
          Count1=0;
          Flag_Timer1=1;
        }
      PIR1.TMR1IF=0;
   }
  */
 }


void Raz_Buffer()
{  int i;
        buffer1[0]=0;
        j=0;
        Index1=0;
        Flag_Buffer =0;
        // nettoye le debut de buffer1 ,car utilis pour init BT
        for(i=0;i<32;i++)buffer1[i]=0;
        i=RCREG;
        RCIE_bit = 1;
}

void UART1_Write_CText(const char *txt1)
 {
   while (*txt1)
      UART1_Write(*txt1++);
}


// --- Copie le texte depuis ROM vers RAM
void strConstRamCpy(char *dest, const char *source) {
  while(*source) *dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF()
{
 UART_Write(CR);
 UART_Write(LF);
}



void Float2Ascii (float x, unsigned char *str,char precision)
{
 /* converts a floating point number to an ascii string */
 /* x is stored into str, which should be at least 30 chars long */
// unsigned char *adpt;
int ie, i, k, ndig;
 double y;
 //adpt=str;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;
 /* if x negative, write minus and reverse */
 if ( x < 0)
 {
   *str++ = '-';
   x = -x;
 }
 /* put x in range 1 <= x < 10 */
 if (x > 0.0) while (x < 1.0)
 {
   x *= 10.0;                // a la place de =*
   ie--;
 }
 while (x >= 10.0)
 {
   x = x/10.0;
   ie++;
 }
 // in f format, number of digits is related to size
 ndig += ie;                                // a la place de =+
 //round. x is between 1 and 10 and ndig will be printed to
 // right of decimal point so rounding is ...
 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
   k = x;
   *str++ = k + '0';
   if (i ==  ie ) *str++ = '.';
   x -= (y=k);
   x *= 10.0;
  }
 *str = '\0';
//return (adpt);
}



void main ()
{
  C1ON_bit = 0;               // Disable comparators
  C2ON_bit = 0;
  ANSELB=0;
  PORTB = 0x00;           // set PORTB to FF
  TRISB = 0;           // designate portb pins as output
  ANSELE=0;
  TRISE=0;
  PORTE=0xFF;
  TRISD=0xFF;

  ANSELA=0;
  PORTA = 0xFF;
  TRISA = 0b11011111;      // RA4 input RA5 output led
  ANSELC=0;
  PORTC = 0x00;
  TRISC = 0xFF; 

  txt=&TEXTE[0];
  UART1_Init(19200);   // RS232
  UART_Set_Active(&UART1_Read, &UART1_Write, &UART1_Data_Ready, &UART1_Tx_Idle); // set UART1 active
  UART1_Write(CLS);
  UART1_Write_CText(mesg0);

  strConstRamCpy(txt,mesg1); UART1_Write_Text(txt);
   // inclue Maths.lib
  UART1_Write_CText("Test calcul cosinus Angle\r\n ");
  for (i=0;i<90;i++)
   {
   df1=(double)i  ;
   df1=df1 *  PI /180.0;
   df2=cos(df1);
   UART1_Write_CText("Cos ");
   WordToStr(i, txt);
   UART1_Write_Text(txt);
   UART1_Write(TAB);
   Float2Ascii (df2,CRam1,5);
   UART1_Write_Text(CRam1);
   CRLF();
   }
   while(1);

}

/*
Divers test avec 18F46K22 Q=20MHz x 4
RS232 UART1  avec interface 2T
Test calcul cosinus Angle
 Cos     0      1.00000
Cos     1       0.99985
Cos     2       0.99939
Cos     3       0.99863
Cos     4       0.99756
Cos     5       0.99619
Cos     6       0.99452
Cos     7       0.99255
Cos     8       0.99027
Cos     9       0.98769
Cos    10       0.98481
Cos    11       0.98163
Cos    12       0.97815
Cos    13       0.97437
Cos    14       0.97030
Cos    15       0.96593
Cos    16       0.96126
Cos    17       0.95630
Cos    18       0.95106
Cos    19       0.94552
Cos    20       0.93969
Cos    21       0.93358
Cos    22       0.92718
Cos    23       0.92050
Cos    24       0.91355
Cos    25       0.90631
Cos    26       0.89879
Cos    27       0.89101
Cos    28       0.88295
Cos    29       0.87462
Cos    30       0.86603
Cos    31       0.85717
Cos    32       0.84805
Cos    33       0.83867
Cos    34       0.82904
Cos    35       0.81915
Cos    36       0.80902
Cos    37       0.79864
Cos    38       0.78801
Cos    39       0.77715
Cos    40       0.76604
Cos    41       0.75471
Cos    42       0.74315
Cos    43       0.73135
Cos    44       0.71934
Cos    45       0.70711
Cos    46       0.69466
Cos    47       0.68200
Cos    48       0.66913
Cos    49       0.65606
Cos    50       0.64279
Cos    51       0.62932
Cos    52       0.61566
Cos    53       0.60182
Cos    54       0.58779
Cos    55       0.57358
Cos    56       0.55919
Cos    57       0.54464
Cos    58       0.52992
Cos    59       0.51504
Cos    60       0.50000
Cos    61       0.48481
Cos    62       0.46947
Cos    63       0.45399
Cos    64       0.43837
Cos    65       0.42262
Cos    66       0.40674
Cos    67       0.39073
Cos    68       0.37461
Cos    69       0.35837
Cos    70       0.34202
Cos    71       0.32557
Cos    72       0.30902
Cos    73       0.29237
Cos    74       0.27564
Cos    75       0.25882
Cos    76       0.24192
Cos    77       0.22495
Cos    78       0.20791
Cos    79       0.19081
Cos    80       0.17365
Cos    81       0.15644
Cos    82       0.13917
Cos    83       0.12187
Cos    84       0.10453
Cos    85       0.08716
Cos    86       0.06976
Cos    87       0.05234
Cos    88       0.03490
Cos    89       0.01745
*/

